import 'package:flutter/material.dart';
import 'package:flutter_compute_tree/flutter_compute_tree.dart';

class InvokeApp extends CTWidget {
  const InvokeApp({super.key});

  @override
  Widget build(BuildContext context) {
    final counter = ref(() => 0);
    final key = counter.value ~/ 3;

    final invokeResult = invoke.immediate(
      () => counter.value ~/ 3,
      key,
    );

    return Column(
      mainAxisAlignment: MainAxisAlignment.center,
      children: [
        const Text('You have pushed the button this many times:'),
        Text(
          '${counter.value}',
          style: Theme.of(context).textTheme.headlineMedium,
        ),
        const SizedBox(height: 16),
        Text(
          'Invokes: $invokeResult',
          style: Theme.of(context).textTheme.bodyMedium,
        ),
        const SizedBox(height: 16),
        ElevatedButton(
          onPressed: () {
            counter.value++;
          },
          child: const Text('Increment'),
        ),
      ],
    );
  }
}
