import 'package:flutter/material.dart';
import 'package:flutter_compute_tree/flutter_compute_tree.dart';

class MemoApp extends CTWidget {
  const MemoApp({super.key});

  @override
  Widget build(BuildContext context) {
    final counter = ref(() => 0);
    final increment = memo(() => counter.value++);

    return Column(
      mainAxisAlignment: MainAxisAlignment.center,
      children: [
        const Text('You have pushed the button this many times:'),
        Text(
          '${counter.value}',
          style: Theme.of(context).textTheme.headlineMedium,
        ),
        const SizedBox(height: 16),
        Text(
          'increment hashCode: ${increment.hashCode}',
          style: Theme.of(context).textTheme.headlineMedium,
        ),
        const SizedBox(height: 16),
        ElevatedButton(
          onPressed: () {
            counter.value++;
          },
          child: const Text('Increment'),
        ),
      ],
    );
  }
}
