import 'package:flutter/material.dart';
import 'package:flutter_compute_tree/flutter_compute_tree.dart';

class TriggerHandlerApp extends CTWidget {
  const TriggerHandlerApp({super.key});

  @override
  Widget build(BuildContext context) {
    final counter = ref(() => 0);
    final increment = trigger();

    final count = increment.handler(
      () => ++counter.value,
      counter.value,
    );

    return Column(
      mainAxisAlignment: MainAxisAlignment.center,
      children: [
        const Text('You have pushed the button this many times:'),
        Text(
          '$count',
          style: Theme.of(context).textTheme.headlineMedium,
        ),
        const SizedBox(height: 16),
        ElevatedButton(
          onPressed: increment,
          child: const Text('Increment'),
        ),
      ],
    );
  }
}
